package com.glavsoft.rfb.client;

import java.security.SecureRandom;
import java.security.AlgorithmParameters;
import java.util.Arrays;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec; // 固定鍵保持のため


public class Aes {
	private static SecretKey secretKey;
	private static IvParameterSpec ivParam;

	private static Cipher cipher_send;
	private static Cipher cipher_recv;

	private static byte[] skey = new byte[] {
		0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	    0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f };
	private static byte[] iv = new byte[] {
		0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
		0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f };

	public Aes() throws Exception
	{
		secretKey= new SecretKeySpec(skey,"AES");
		ivParam = new IvParameterSpec(iv);

		cipher_send = Cipher.getInstance("AES/CTR/NoPadding");	
		cipher_recv = Cipher.getInstance("AES/CTR/NoPadding");	

		cipher_send.init(Cipher.ENCRYPT_MODE, secretKey, ivParam);
		cipher_recv.init(Cipher.DECRYPT_MODE, secretKey, ivParam);
	}

	public void key_init() throws Exception
	{
		cipher_send.init(Cipher.ENCRYPT_MODE, secretKey, ivParam);
		cipher_recv.init(Cipher.DECRYPT_MODE, secretKey, ivParam);
	}

	private static void log(int input, int enc, int dec)
	{
		System.out.printf("input:0x%04x(%c) -> enc:0x%04x -> dec:0x%04x(%c)\n",input,input,enc,dec,dec);
	}

	
	public int kbd_encrypt(int input)
	{
		byte[] plain = new byte[2];
		byte[] enc = new byte[2];
		byte[] dec = new byte[2];

		plain = divide_int_to_byte(input);

		try { 
			enc = cipher_send.update(plain,0,plain.length);

			//dec = cipher_recv.update(enc,0,enc.length); /* debug */
		}
		catch (Exception e) { System.out.println(e); }

		//log(combine_byte_to_int(plain),combine_byte_to_int(enc),combine_byte_to_int(dec));

		return combine_byte_to_int(enc);
	}


	private byte[] divide_int_to_byte(int input)
	{
		byte[] divide = new byte[2];
		divide[0] = (byte)(input & 0x00ff);
		divide[1] = (byte)((input & 0xff00)>>8);
		return divide;
	}


	private int combine_byte_to_int(byte[] encrypted)
	{
		int[] tmp = new int[2];
		tmp[0] = encrypted[0] & 0x0000ff;
		tmp[1] = (encrypted[1]<<8) & 0x0000ff00;
		return ( tmp[0] | tmp[1] ) & 0x0000ffff;
	}
}
