/*
 * configure.h: FBCrypt config
 *
 */

#ifndef FBCRYPT_CONFIGURE_H_cbf3e726
#define FBCRYPT_CONFIGURE_H_cbf3e726

#include "domain_info.h"

/* TIME */
#define TIME_HVM_KBD 0
#define TIME_HVM_SCREEN 0
#define TIME_PV_KBD 0
#define TIME_PV_SCREEN 0

/* DEBUG LOG */
#define DEBUG_VKBD_INFO 0 	/* VKBD_WRITE_LOG */
#define DEBUG_RC4_INFO 0	/* VKBD_DECRYPT_LOG */
#define DEBUG_HVM_SC 0		/* HVM SCREEN LOG */

/* MODE */
#define FBCRYPT_PV	1	/* ON/OFF FBcrypt_PV */
#define FBCRYPT_HVM	0	/* ON/OFF FBcrypt_PV */

/* PV */
#if FBCRYPT_PV
#define FBCRYPT_PV_INPUT 1
#define FBCRYPT_PV_OUTPUT 1
#endif

/* HVM */
#if FBCRYPT_HVM
#define FBCRYPT_HVM_INPUT 1	/* ON/OFF FBcrypt_HVM */
#define FBCRYPT_HVM_OUTPUT 1 /* ON/OFF FBcrypt_HVM SCREEN */
#endif
#define FBCRYPT_XGA 1 /* resolution 1024x768 */
#define FBCRYPT_VGA 0 /* resolution 800x600 */

#define MYLOG() printk("%s:%s:%d\n",__FILE__,__FUNCTION__,__LINE__)


/* for Keyboard */
typedef struct FBCRYPT_info {
	V_TYPE mode;
	int domid;
	int down;
	int seq;
	int reset;
	int sha;
	unsigned int hash[4];
} FBCRYPT_info;

#endif /* FBCRYPT_CONFIGURE_H_cbf3e726 */
