/*
 * xen/fbcrypt/keycode/keycode.h
 *
 * 復号化した input 情報をkeycodeへ変換
 *
 */

#ifndef KEYCODE_H_158aa0b3
#define KEYCODE_H_158aa0b3

#define MAX_NORMAL_KEYCODE 512
#define MAX_EXTRA_COUNT 256

typedef struct key_range {
    int start;
    int end;
    struct key_range *next;
} key_range_t;

typedef struct {
    uint16_t keysym2keycode[MAX_NORMAL_KEYCODE];
    struct {
	int keysym;
	uint16_t keycode;
    } keysym2keycode_extra[MAX_EXTRA_COUNT];
    int extra_count;
    struct key_range *keypad_range;
    struct key_range *numlock_range;
    struct key_range *shift_range;
    struct key_range *localstate_range;
    struct key_range *altgr_range;
} kbd_layout_t;

typedef struct VncState
{
    kbd_layout_t *kbd_layout;
    uint8_t modifiers_state[256]; /* input */
}VncState;

/* sym => keycode */
int do_key_event(VncState *vs, int down, uint32_t sym, int mode);

void init_vs(VncState *vs, kbd_layout_t *kbd);
void init_vs2(VncState *vs);

#endif /* KEYCODE_H_158aa0b3 */
